> For the complete documentation index, see [llms.txt](https://docs.carbondefi.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/tokenstraded.md).

# TokensTraded()

{% code title="CarbonController.sol" overflow="wrap" lineNumbers="true" %}

```solidity
   event TokensTraded(
        address indexed trader,
        address indexed sourceToken,
        address indexed targetToken,
        uint256 sourceAmount,
        uint256 targetAmount,
        uint128 tradingFeeAmount,
        bool byTargetAmount
    );
```

{% endcode %}

This event is emitted when tokens are traded into one or more strategies.

### Event Parameters

| Name             | Type    | Description                                                                                                                                                                            |
| ---------------- | ------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| trader           | address | The address that performed the trade.                                                                                                                                                  |
| sourceToken      | address | The token traded from.                                                                                                                                                                 |
| targetToken      | address | The token traded to.                                                                                                                                                                   |
| sourceAmount     | uint256 | The number of source tokens traded.                                                                                                                                                    |
| targetAmount     | uint256 | The number of target tokens received.                                                                                                                                                  |
| tradingFeeAmount | uint128 | The number of tokens earned by Carbon DeFi as a fee.                                                                                                                                   |
| byTargetAmount   | bool    | <p><strong>True:</strong> the trade was done using the tradeByTargetAmount() function. </p><p><strong>False:</strong> the trade was done using the tradeBySourceAmount() function.</p> |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/tokenstraded.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
